# SparkBorrow

### Description

Borrow a token from Spark market

> **Notes**
>
> User borrows tokens from the Spark protocol

### Action ID

`0x9bc097ab`

### SDK Action

```ts
const sparkBorrowAction = new dfs.actions.spark.SparkBorrowAction(
    useDefaultMarket,
    market,
    amount,
    to,
    rateMode,
    assetId,
    useOnBehalf,
    onBehalf
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param amount Amount of tokens to borrow
    /// @param to Address to send the borrowed tokens to
    /// @param rateMode Type of borrow debt [Stable: 1, Variable: 2]
    /// @param assetId The id of the token to be borrowed
    /// @param useDefaultMarket Whether to use the default market
    /// @param useOnBehalf Whether to borrow on behalf of another address
    /// @param market Address of the market to borrow from
    /// @param onBehalf Address to borrow on behalf of
    struct Params {
        uint256 amount;
        address to;
        uint8 rateMode;
        uint16 assetId;
        bool useDefaultMarket;
        bool useOnBehalf;
        address market;
        address onBehalf;
    }
```

### Return Value

```solidity
return bytes32(borrowAmount);
```

### Events and Logs

```solidity
emit ActionEvent("SparkBorrow", logData);
logger.logActionDirectEvent("SparkBorrow", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.defisaver.com/actions/spark/sparkborrow.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
